/*
 * GND.java
 *
 * Created on 3 de mayo de 2007, 02:06 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
//package componenteselectricos;
import java.awt.*;
import java.awt.event.*;
import javax.swing.JPanel.*;
import javax.swing.JLabel.*;
import java.awt.GridLayout;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JProgressBar;
import java.awt.FlowLayout;
import javax.swing.BoxLayout;
import javax.swing.BoxLayout.*;
import java.awt.geom.Line2D;
import java.awt.geom.Line2D.Double.*;
import java.awt.geom.Line2D.Double;
import java.awt.Rectangle;
import java.awt.Graphics;
import java.awt.event.*;
import java.text.*;
import javax.swing.*;
import javax.swing.JOptionPane.*;
import java.awt.HeadlessException.*;
import javax.swing.JOptionPane;
import javax.swing.JDialog;
import java.awt.*;
import java.lang.String;
import java.awt.Graphics2D;
/**
 *
 * @author Francisco Olivares
 * @author Cristhoper Jana
 */
public class GND extends Linea implements Cloneable {
    private int orientacion = 1;
    /** Creates a new instance of GND */
    public GND() {
        super();
        abajoDerecha.setLocation(arribaIzquierda.getX(),
                arribaIzquierda.getY());
    }
    public GND(int x,int y) {
        super(x,y);
        abajoDerecha.setLocation(x,y);
    }
    /**
     * Retorna el sentido de rotacion de la figura. Asociado a los
     * grados de rotacion 0 ,90 ,180 ,270 .
     * @return 1,2,3,4 respectivamnte
     */
    public int getOrientacion() {
        return(orientacion);
    }
    /**
     * Ajusta el grado de rotacion 0 ,90 ,180 ,270 .
     * @param value Entero 1,2,3,4 asociado al grado de rotacion
     */
    public void setOrientacion(int value) {
        orientacion = value;
    }    
    public void mover(int x, int y) {
        super.mover(x,y);
        int xa = super.getArribaIzquierdaX();
        int ya = super.getArribaIzquierdaY();
        abajoDerecha.setLocation(xa, ya);
    }    
    public void rotar() {
        orientacion++;
        if(orientacion > 4) {
            orientacion = 1;
        }
    }
    public Graphics dibujate(Graphics g) {
        int xa = super.getArribaIzquierdaX();
        int ya = super.getArribaIzquierdaY();
        int r  = LARGODELASFIGURAS / 4;
        switch(orientacion) {
            case 1:
                g.drawLine( xa,
                            ya,
                            xa,
                            ya + 2*r);
                g.drawLine( xa - r,
                            2*r + ya,
                            xa + r,
                            2*r + ya);
                g.drawString("GND",xa,(int)(ya + 2.6*r));
                break;
            case 2:
                g.drawLine( xa,
                            ya,
                            xa + 2*r,
                            ya);
                
                g.drawLine( xa + 2*r,
                            ya - r,
                            xa + 2*r,
                            ya + r);
                g.drawString("GND",xa,(int)(ya + 2.6*r - 2*r));
                break;  
            case 3:
                g.drawLine( xa,
                            ya - 2*r,
                            xa,
                            ya);//parte vertical une punto xa,ya
                g.drawLine( xa - r,
                            ya - 2*r,
                            xa + r,
                            ya - 2*r);//parte horizontal de arriba
                g.drawString("GND",xa,(int)(ya - 2*r));                
                break;
            case 4:
                g.drawLine( xa,
                            ya,
                            xa - 2*r,
                            ya);
                
                g.drawLine( xa - 2*r,
                            ya - r,
                            xa - 2*r,
                            ya + r);
                g.drawString("GND",xa - 2*r,(int)(ya + 2.6*r - 2*r));                
                break;
        }
        return(g);
    }
    public boolean contiene(int x, int y) {
        int xa = super.getArribaIzquierdaX();
        int ya = super.getArribaIzquierdaY();
        int r  = LARGODELASFIGURAS / 4;
        Rectangle rectTemp1;
        Rectangle rectTemp2;        
        switch(orientacion) {
            case 1:
                rectTemp1 = new Rectangle(xa - ANCHORECTANGULOCAMBIOCOLOR,
                        ya - ANCHORECTANGULOCAMBIOCOLOR,
                        2*ANCHORECTANGULOCAMBIOCOLOR,
                        2*r + 2*ANCHORECTANGULOCAMBIOCOLOR );
                rectTemp2 = new Rectangle(xa - r - ANCHORECTANGULOCAMBIOCOLOR,
                        2*r + ya - ANCHORECTANGULOCAMBIOCOLOR,
                        2*r + 2*ANCHORECTANGULOCAMBIOCOLOR,
                        2*ANCHORECTANGULOCAMBIOCOLOR );                
                break;
            case 2:
                rectTemp1 = new Rectangle(xa - ANCHORECTANGULOCAMBIOCOLOR,
                        ya - ANCHORECTANGULOCAMBIOCOLOR,
                        2*r + 2*ANCHORECTANGULOCAMBIOCOLOR,
                        2*ANCHORECTANGULOCAMBIOCOLOR );
                rectTemp2 = new Rectangle(xa + 2*r - ANCHORECTANGULOCAMBIOCOLOR,
                        ya -r - ANCHORECTANGULOCAMBIOCOLOR,
                        2*ANCHORECTANGULOCAMBIOCOLOR,
                        2*r + 2*ANCHORECTANGULOCAMBIOCOLOR );
                break;
            case 3:
                rectTemp1 = new Rectangle(xa - ANCHORECTANGULOCAMBIOCOLOR,
                        ya - 2*r - ANCHORECTANGULOCAMBIOCOLOR,
                        2*ANCHORECTANGULOCAMBIOCOLOR,
                        2*r + 2*ANCHORECTANGULOCAMBIOCOLOR );
                rectTemp2 = new Rectangle(xa - r - ANCHORECTANGULOCAMBIOCOLOR,
                        ya -2*r - ANCHORECTANGULOCAMBIOCOLOR,
                        2*r + 2*ANCHORECTANGULOCAMBIOCOLOR,
                        2*ANCHORECTANGULOCAMBIOCOLOR );
                break;    
            case 4:
                rectTemp1 = new Rectangle(xa -2*r - ANCHORECTANGULOCAMBIOCOLOR,
                        ya -ANCHORECTANGULOCAMBIOCOLOR,
                        2*r + 2*ANCHORECTANGULOCAMBIOCOLOR,
                        2*ANCHORECTANGULOCAMBIOCOLOR );
                rectTemp2 = new Rectangle(xa -2*r - ANCHORECTANGULOCAMBIOCOLOR,
                        ya -r - ANCHORECTANGULOCAMBIOCOLOR,
                        2*ANCHORECTANGULOCAMBIOCOLOR,
                        2*r + 2*ANCHORECTANGULOCAMBIOCOLOR );
                break; 
            default:
                rectTemp1 = new Rectangle(xa - ANCHORECTANGULOCAMBIOCOLOR,
                        ya - ANCHORECTANGULOCAMBIOCOLOR,
                        2*ANCHORECTANGULOCAMBIOCOLOR,
                        2*r + 2*ANCHORECTANGULOCAMBIOCOLOR );
                rectTemp2 = new Rectangle(xa - r - ANCHORECTANGULOCAMBIOCOLOR,
                        2*r + ya - ANCHORECTANGULOCAMBIOCOLOR,
                        2*r+2*ANCHORECTANGULOCAMBIOCOLOR,
                        2*ANCHORECTANGULOCAMBIOCOLOR );                
                break;                
        }
        return(rectTemp1.contains(x,y) || rectTemp2.contains(x,y));
    }
    /**
     * Metodo que implementa el clone de la clase Lineas.
     * DEBE ESTAR DEFINIDO.
     * @return Objeto que debe ser casteado a cable (identico al entregado),
     *  tipo Object.
     *  Implementado para FuenteCC
     */
    public Object clone() {
        Object obj = null;
        obj = new GND(this.getArribaIzquierdaX(),
                           this.getArribaIzquierdaY());
        ((Linea)obj).cambioDeColor(this.getColor());
        ((GND)obj).setOrientacion(this.getOrientacion());
        return(obj);
    }
}
