/*
 * InfoLabel.java
 *
 * Created on 30 de abril de 2007, 04:20 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

import javax.swing.JLabel;
/**
 * Este clase crea el label, el cual contien informacion
 * sobre las acciones que se estan realizando.
 * @author Francisco Olivares
 * @author Cristhoper Jana
 */
public class InfoLabel implements InfoInterfaz{
    private static JLabel informacionLabel;
    /** Creates a new instance of InfoLabel
     */
    public InfoLabel() {
        informacionLabel = new JLabel("");
    }
    /** Creates a new instance of InfoLabel,
     *  Segundo constructor.
     */
    public InfoLabel(String text) {
        informacionLabel = new JLabel(text);
    }
    /** Setea el texto del label con el texto dado por
     *  referencia.
     *  @param text Este es el texto que setea el label.
     */
    public void setLabelText(String text) {
        informacionLabel.setText(text);
    }
    /** Este metodo retorna lo que hay en el label.
     *  @return lo que hay en el label.
     */
    public String getLabelText() {
        return(informacionLabel.getText());
    }
    /** Este metodo manda el label a donde se lo pidan.
     *  @return El label actual.
     */
    public JLabel getLabel() {
        return(informacionLabel);
    }
    /** este metodo imprime por consola lo que esta en el
     *  label.
     */
    public void toConsola() {
        System.out.println(informacionLabel.getText());
    }
}
