/*
 * MenusListeners.java
 *
 * Created on 30 de abril de 2007, 12:30 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
//package componenteselectricos;
import java.awt.*;
import java.awt.event.*;
import java.text.*;
import javax.swing.*;
import javax.swing.JOptionPane.*;
import java.awt.HeadlessException.*;
import javax.swing.JOptionPane;
import javax.swing.JDialog;
import java.awt.*;
/**
 *  Este es el que escucha las interrupciones que genra el menu.
 * @author Francisco Olivares
 * @author Cristhoper Jana
 */
public class MenusListeners implements ActionListener {
    public static final int NINGUNAOP = 0;
    public static final int RESISTENCIA = 1;
    public static final int TIERRA = 2;
    public static final int FUENTE = 3;
    public static final int TRASLADAR = 4;
    public static final int ROTAR = 5;
    private int menuItemActual;
    private static InfoInterfaz informacionLabel;
    private static ListaDeLineasInterfaz listaDeLineasInterfaz;
    private static PanelInterfaz PanelGraficoInterfaz;
    public static int opcionActual = NINGUNAOP;
    /** Creates a new instance of MenusListeners */
    public MenusListeners(int variableActivada) {
        menuItemActual = variableActivada;
    }
    public static void setInfoInterfaz(InfoInterfaz info) {
        informacionLabel = info;
    }
    public static void setListaDeLineasInterfaz(ListaDeLineasInterfaz inter) {
        listaDeLineasInterfaz = inter;
    }
    public static void setPanelGraficoInterfaz(PanelInterfaz inter) {
        PanelGraficoInterfaz = inter;
    }
    public void actionPerformed(ActionEvent event) {
        boolean todoOk = true;
        switch(menuItemActual) {
            case RESISTENCIA:
                opcionActual = RESISTENCIA;
                informacionLabel.setLabelText("RESISTENCIA");
                int resistenciaEnOmh;
                do{
                    try{
                        todoOk = true;
                        String textoTiempo =
                                JOptionPane.showInputDialog("Cuanto" +
                                " es el valor de la resistencia, en [ohm]");
                        resistenciaEnOmh = Integer.parseInt(textoTiempo.trim());
                    }catch(NumberFormatException ex) {                        
                        resistenciaEnOmh = -10;
                        JOptionPane.showMessageDialog(null,"Error,\nEl dato" +
                                " pasado no es un numero");
                    }catch(java.lang.NullPointerException ex) {
                        todoOk = false;
                        resistenciaEnOmh = -10;
                    }
                }while(!(resistenciaEnOmh > 0) && todoOk);
                if(todoOk == true)
                    listaDeLineasInterfaz.add(new Resistencia(resistenciaEnOmh));
                PanelGraficoInterfaz.repaint();
                opcionActual = NINGUNAOP;
                break;
            case TIERRA:
                opcionActual = TIERRA;
                informacionLabel.setLabelText("TIERRA");
                listaDeLineasInterfaz.add(new GND());
                // crear la tierra
                opcionActual = NINGUNAOP;
                break;
            case FUENTE:
                opcionActual = FUENTE;
                informacionLabel.setLabelText("FUENTE");
                // crear la fuente
                int VoltajeEnVolts;
                
                do{
                    try{
                        todoOk = true;
                        String textoTiempo =
                                JOptionPane.showInputDialog("Cuanto" +
                                " es el valor del voltaje, en [volt]");
                        VoltajeEnVolts = Integer.parseInt(textoTiempo.trim());
                    }catch(NumberFormatException ex) {
                        VoltajeEnVolts = -5;
                        JOptionPane.showMessageDialog(null,"Error,\nEl dato" +
                                " pasado no es un numero");                        
                    }catch(java.lang.NullPointerException ex) {
                        VoltajeEnVolts = -5;
                        todoOk = false;
                    }
                }while(!(VoltajeEnVolts > 0) && todoOk);
                if(todoOk == true)
                    listaDeLineasInterfaz.add(new FuenteCC(VoltajeEnVolts));
                PanelGraficoInterfaz.repaint();
                opcionActual = NINGUNAOP;
                break;
            case TRASLADAR:
                opcionActual = TRASLADAR;
                informacionLabel.setLabelText("TRASLADAR");
                break;
            case ROTAR:
                opcionActual = ROTAR;
                informacionLabel.setLabelText("ROTAR");
                break;
        }
    }
}
