/*
 * MouseMotionListeners.java
 *
 * Created on 30 de abril de 2007, 09:16 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

import java.awt.event.*;
/**
 *
 * @author Francisco Olivares
 * @author Cristhoper Jana
 */
public class MouseMotionListeners implements MouseMotionListener {
    private static InfoInterfaz informacionLabel;
    private static ListaDeLineasInterfaz listaDeLineasInterfaz;
    private static PanelInterfaz PanelGraficoInterfaz;
    /** Creates a new instance of MouseMotionListeners */
    public MouseMotionListeners() {
    }
    public static void setInfoInterfaz(InfoInterfaz info) {
        informacionLabel = info;
    }
    public static void setListaDeLineasInterfaz(ListaDeLineasInterfaz inter) {
        listaDeLineasInterfaz = inter;
    }
    public static void setPanelGraficoInterfaz(PanelInterfaz inter) {
        PanelGraficoInterfaz = inter;
    }
    public void mouseMoved(MouseEvent event) {
        if(MenusListeners.opcionActual == MenusListeners.TRASLADAR ||
                    MenusListeners.opcionActual == MenusListeners.ROTAR) {
            listaDeLineasInterfaz.contiene(event.getX(),event.getY());
            PanelGraficoInterfaz.repaint();
        }
    }
    public void mouseDragged(MouseEvent event) {
        if(MenusListeners.opcionActual != MenusListeners.TRASLADAR &&
                    MenusListeners.opcionActual != MenusListeners.ROTAR)
            informacionLabel.setLabelText("arrastrando: (" +
                (int)(MouseInputListeners.puntoInicial).getX()+","+
                (int)(MouseInputListeners.puntoInicial).getY()+")");
        switch(MenusListeners.opcionActual) {
            case MenusListeners.TRASLADAR:
                if(listaDeLineasInterfaz.tengoTomadaUnaComponente()) {
                    listaDeLineasInterfaz.recargarComponenteTomadaConRespaldo();
                    int deltaX = (int)event.getX() -
                            (int)MouseInputListeners.puntoInicial.getX();
                    int deltaY = (int)event.getY() -
                            (int)MouseInputListeners.puntoInicial.getY();
                    listaDeLineasInterfaz.mover(deltaX, deltaY);
                    PanelGraficoInterfaz.repaint();
                }
                break;
            case MenusListeners.ROTAR:
                //
                // no hacer nada
                //
                break;
        }
    }
}
